import java.util.Scanner;

/* class SinavDagilim
 * Authors: zlem Grses, Hseyin Yaar, Didem Kayal
 * Beta Tester: Umut Benzer
 */
public class SinavDagilim {
	
	/* function kacSinirKullanilacak
	 * Author: Hseyin Yaar
	 *
	 * @param: renci says ve snf kapasiteleri
	 * @return: rencilerin ka snfa yerletirilecei
	 */
	private static int kacSinifKullanilacak(int ogrSayi, int sinifKapasite[]) {
		int kapasitelerToplami = 0;
		int kullanilacakSinifSayisi = 0;
		for (int i = 0; i < 5; i++) {
			kapasitelerToplami+=sinifKapasite[i];
			kullanilacakSinifSayisi++;
			if(kapasitelerToplami>=ogrSayi)
				break;
		}
		return kullanilacakSinifSayisi;
	}
	
	/* function dagilimBul
	 * Author: Hseyin Yaar
	 *
	 * @param: Sralanm snf kapasiteleri, renci says, bo snf mevcudu dizisi
	 * @return: Snflara kaar kii koyulacann bilgisi
	 */
	private static void dagilimBul(int sinifKapasite[], int ogrSayi,
			int sinifMevcut[]) {
		int kapasitelerToplami = 0;
		int a = kacSinifKullanilacak(ogrSayi, sinifKapasite);
		float[] sinifMevcutOndalikli = new float[a];
		float kusuratlarToplami = 0;
		for (int i = 0; i < a; i++) {
			kapasitelerToplami += sinifKapasite[i];
		}
		for (int i = 0; i < a; i++) {
			sinifMevcutOndalikli[i] = sinifKapasite[i]
					* ((float) ogrSayi / (float) kapasitelerToplami);
			sinifMevcut[i] = (int) sinifMevcutOndalikli[i];
			kusuratlarToplami += sinifMevcutOndalikli[i] - sinifMevcut[i];
		}

		if (kusuratlarToplami > 0) {
			for (int i = 0; i < a; i++) {
				sinifMevcut[i]++;
				kusuratlarToplami--;
				if (kusuratlarToplami <= 0)
					break;
				/* ksratlarn toplam olan tamsayy soldan saa 
				 * birer birer bitene kadar datr
				 * kusuratlar toplam daima tamsay gelmesi gereken bir 
				 * saydr, rnein 0.2 ve 0.8 gibi artanlar olur,
				 * bunlarn toplam daima tamsaydr, ama bazen blmlerde
				 * 0.19999999 ve 0.7999999999 gibi saylar gelebilir,
				 * bunlarn toplamlar 0.999999 gibi saylardr, dolaysyla
				 * 1 eksildii zaman 0'n altna der, bu yzden if satrnda 
				 * kktr ibaresi kullanlmtr.
				 */	 				
			}
		}
	}
	
	/* function sirala
	 * Author: Didem Kayal
	 *
	 * @param: Sralanacak integer dizisi
	 * @return: Sralanm integer dizisi (bykten ke)
	 *
	 * Dizi referans olarak gnderileceinden void dndrmesi
	 * yeterlidir. Asl deiiklikler asl diziye yanstlr.
	 */
	private static void sirala(int sinifKapasite[]) {
		/* Standart Bubble Sort Algoritmas */
		for (int i = 0; i < sinifKapasite.length - 1; i++) {
			for (int j = i + 1; j < sinifKapasite.length; j++) {
				if (sinifKapasite[j] > sinifKapasite[i]) {
					int b = sinifKapasite[j];
					sinifKapasite[j] = sinifKapasite[i];
					sinifKapasite[i] = b;
				}
			}
		}
	}
	
	/* function dagit
	 * Author: zlem Grses
	 *
	 * @param: Sralanm snf kapasiteleri, ierilerine yerletirilecek renci says
	 * @return: Ekrana kt
	 */
	private static void dagit(int sinifKapasite[], int sinifMevcut[]) {
		String ad[] = { "umut", "didem", "zlem", "hseyin", "hlya", "banu",
				"ajdar","aye","mehmet","hsn","canan","metin","okan" };
		String soyad[] = { "benzer", "kayal", "grses", "yaar", "avar",
				"alkan", "ank","sert","and","ylmaz","ahin","kurt","elik",
				"boya","hyk","gler","sever","ceylan"};
		
		/*
		 * "" saysnn fazla olmas, daha az ek seilmesini salamaya
		 * yneliktir.
		 */
		String ekleAd[] = { "can", "gl", "nur", "su", "","","" };
		String ekleSoyad[] = { "olu", "gil", "z", "","","","" };

		for (int i = 0; i <= sinifKapasite.length-1; i++) { /* UBenzer dzenleme */
			if(sinifKapasite[i]==0) {
				System.out.print((i+1)+". snf bo snftr.\n");
			} else if(sinifMevcut[i]==0){
				System.out.print(sinifKapasite[i]+" kiilik snfa renci yerletirilmemitir.\n");
			} else {
				float ort = (float) 100 * sinifMevcut[i] / sinifKapasite[i];
				System.out.println("\n\n" + sinifKapasite[i] + " kiilik snfa "
					+ sinifMevcut[i]
					+ " kii yerletirildi.\nsnfn doluluk oran: " + ort
					+ " %dr.");
				for (int k = 0; k < sinifMevcut[i]; k++) {
					String yeniIsim = ad[(int) (Math.random() * ad.length)]
							.concat(ekleAd[(int) (Math.random() * ekleAd.length)]);
					String yeniSoyisim = soyad[(int) (Math.random() * soyad.length)]
							.concat(ekleSoyad[(int) (Math.random() * ekleSoyad.length)]);
					int yil = (int) (Math.random() * 8);
					System.out.print((k+1) + ". 05-0"
							+ yil + "-" + (int) (Math.random() * 9)
							+ (int) (Math.random() * 9) + (int) (Math.random() * 9)
							+ (int) (Math.random() * 9) + " "+yeniIsim + " " + yeniSoyisim+"\n");
				}			
			}
		}

	}
	
	/* function main
	 * Author: Hseyin Yaar
	 */
	public static void main(String[] args) {
		int[] sinifKapasite = new int[5];
		int[] sinifMevcut = new int[5];
		int ogrSayi;
		int top;
		int kntrl = 0;
		Scanner str = new Scanner(System.in);
		do {
			top=0;
			if(kntrl==1)
				System.out.println("Hatal giri.");
			
			System.out.println("Yerlestirilecek ogrenci sayisini giriniz: ");
			ogrSayi = str.nextInt();
			if(ogrSayi < 100 || ogrSayi > 200){
				 kntrl = 1;
				 continue;
			}
		
			for(int i=0; i<sinifKapasite.length; i++){
			System.out.println((i+1)+". sinifin kapasitesini giriniz: ");
				sinifKapasite[i]=str.nextInt();
				if(sinifKapasite[i]<0) {
					kntrl = 1;
					break;
				}
				top+=sinifKapasite[i];
			}
			if(top < ogrSayi) {
				 kntrl = 1;
			} else {
				kntrl = 0;
			}
		} while(kntrl==1);
			
		sirala(sinifKapasite);
		dagilimBul(sinifKapasite, ogrSayi, sinifMevcut);
		/* Hata ayklama */
		System.out.println(sinifMevcut[0] +  " " + sinifMevcut[1] +  " " + sinifMevcut[2] +  " " + sinifMevcut[3] +  " " + sinifMevcut[4] +  " " );
		dagit(sinifKapasite, sinifMevcut);
	}
}
